var tabla;
//declaramos variables necesarias para trabajar con las Ventas y sus detalles
var impuesto                =$("#impuesto").val();
console.log(impuesto);
var cont                    =0;
var cont1                   =0;
var detalles				=0;
var indicepermisoborrar     =-50;
var impuestoart18_empresa	=	$('#impuestoart18_empresa').val();
var pvpt                    = '';
var ImpuestoArt18           = '';
var tdtd                    = '';
var ivapercep               = '';


if (impuestoart18_empresa=="si"){
    pvpt            = '<th>Precio (PVP)</th>';
    ImpuestoArt18   = '<th>ImpuestoArt18</th>';
    tdtd            = '<td></td><td></td>';
    ivapercep       = '<tr><td></td><td></td><td></td><td></td><td></td><td></td><td>Iva Percepción</td><td align="right"><p id="ivap"></p></td><td align="right"><p id="ivapd"></p></td></tr>';
}

var r = '<thead style="background-color:#A9D0F5">'+
		'<th width=10>Opciones</th>'+
		'<th>Articulo</th>'+
		'<th>Cantidad</th>'+
		'<th>Precio</th>'+
		pvpt+
		'<th>Porcentaje</th>'+
		'<th>Descuento</th>'+
		ImpuestoArt18+
		'<th>Subtotal</th>'+
		'</thead>'+
		'<tfoot>'+
		'<tr>'+
		'	<td></td>'+
		'	<td></td>'+
		'	<td></td>'+
        tdtd+
		'	<td></td>'+
		'	<td>Sub-Total</td>'+
		'	<td align="right"><p id="subtotal"></p></td>'+
		'	<td align="right"><p id="subtotald"></p></td>'+
		'</tr>'+
		'<tr>'+
		'	<td></td>'+
		'	<td></td>'+
		'	<td></td>'+
		'	<td></td>'+
        tdtd+
		'	<td>Iva</td>'+
		'	<td align="right"><p id="iva"></p></td>'+
		'	<td align="right"><p id="ivad"></p></td>'+
		'</tr>'+
        ivapercep+
		'<tr>'+
		'	<td></td>'+
		'	<td></td>'+
		'	<td></td>'+
		'	<td></td>'+
        tdtd+
		'	<td>Exento</td>'+
		'	<td align="right"><p id="exento"></p></td>'+
		'	<td align="right"><p id="exentod"></p></td>'+
		'</tr>'+
		'<tr>'+
		'	<th></th>'+
		'	<th></th>'+
		'	<th></th>'+
		'	<th></th>'+
		tdtd+
		'	<th>TOTAL</th>'+
		'	<th align="right"><h4 align="right" id="total"></h4>'+
		'	<th align="right"><h4  align="right" id="totald"></h4></th>'+
		'	  <input type="hidden" name="total_venta1" id="total_venta1" disabled>'+
		'	  <input type="hidden" name="total_venta" id="total_venta">'+
		'	  <input type="hidden" name="total_ventad" id="total_ventad">'+
		'	  <input type="hidden" name="total_ventai" id="total_ventai">'+
		'	  <input type="hidden" name="total_ventaid" id="total_ventaid">'+
		'	</th>'+
		'</tr>'+
		'</tfoot>'+
		'<tbody>'+
		'</tbody>';

$("#btnGuardar").hide();
$("#tipo_comprobante").change(marcarImpuesto);

//funcion que se ejecuta al inicio
function init(){
   mostrarform(false);
   listar();
   	
	/*Se captura el evento de guardar los datos */
	$("#btnFacturar").on("click",function(e){
		/* Evitamos el envío real del formulario */
			e.preventDefault(); 
			validar();
			//console.log(detalles);
			if (detalles<=0){
				bootbox.alert('No agregado producto a su compra');
			}else{
				var val = $("#validado").val();
				//console.log(val);
				if (val==1){  
					// Se va a guardar la factura
					bootbox.confirm("¿Esta seguro que quiere guardar los dato?", function(result){
					if (result) {
						modificarValoresAnumerico();
						guardaryeditar(e);	
						}
					})
				}	
			}
	});

		   
	/*Se captura para guardar el cliente */   
	$("#formaguardarcliente").on("submit",function(e){
		/* Evitamos el envío real del formulario */
		e.preventDefault();
		$('#myModalCliente').modal('hide');   
		guardarcliente();
	});

	/*Se captura el evento de buscar clave de permiso */   
	$("#formapermiso").on("submit",function(e){
		/* Evitamos el envío real del formulario */
		e.preventDefault();
		$('#myModalPermiso').modal('hide');   
		buscarClave();
	});

	
	// Se busca el codigo de barra
    $("#cod_barra").keypress(function(e) {
		var keycode = (e.keyCode ? e.keyCode : e.which);
		var codigobarra = $("#cod_barra").val();
		if (keycode == '13') {
			// Evitamos el envío real del enter
			e.preventDefault();
			// Hacemos la llamada al API Buscamos el codigo de barra
			buscarcodigodebarra(codigobarra);
			return false;
		}
	});

	//Capturamos los campos de los articulos pata totalizar

	// Se busca el cliente
	//setup before functions
	var typingTimer;                //timer identifier
	var doneTypingInterval = 5000;  //time in ms, 1 second for example
	var $input = $('#num_documento');

	//Se inicia el conteo para buscar el cliente
	$input.on('keyup', function () {
     	clearTimeout(typingTimer);
     	typingTimer = setTimeout(doneTyping, doneTypingInterval);
	});

	//Se limpia el contador cuando deja de escribir
	$input.on('keydown', function () {
     	clearTimeout(typingTimer);
	});

	//buscamos el cliente
	function doneTyping () {
		var tipo_documento	=	$("#tipo_documento").val();
		var num_documento	=	$("#num_documento").val();
		buscarcliente(tipo_documento,num_documento);
	}

    $("#num_documento").keypress(function(e) {
		var keycode = (e.keyCode ? e.keyCode : e.which);
		if (keycode == '13') {
			// Evitamos el envío real del enter
			e.preventDefault();
			// Hacemos la llamada al API Buscamos el codigo de barra
			var tipo_documento	=	$("#tipo_documento").val();
			var num_documento	=	$("#num_documento").val();
			buscarcliente(tipo_documento,num_documento);
			return false;
		}
	}); 


	/* Tras cargar el documento posicionamos el cursor en el lector de código de barras */
    document.addEventListener('DOMContentLoaded', function() {
		$("#cod_barra").val("");
		$("#cod_barra").focus();	
	});

	//se verifica si cambia los campos del formulario
	$("#idcliente").change(function(){
		buscarclienteid($("#idcliente").val());
		$("#cod_barra").val("");
		$("#cod_barra").focus();
	});

	$("#tipo_comprobante").change(function(){
		$("#cod_barra").val("");
		$("#cod_barra").focus();
	});

	$("#fecha_hora").change(function(){
		$("#cod_barra").val("");
		$("#cod_barra").focus();
	});

	//se verifica si cambia los campos del formulario
	$("#idcliente").change(function(){
		buscarclienteid($("#idcliente").val());
		buscardespachoid($("#idcliente").val());
		$("#cod_barra").val("");
		$("#cod_barra").focus();
	}); 
	


//    $("#btnGuardarCompra").on("click",function(e){
// 	guardaryeditar(e);  
//    })

   //cargamos los items al select cliente
   $.post("controladores/ventanControlador.php?op=selectClienteCita", function(r){
	$("#idcliente").html(r);
	$("#idcliente").val(0);
   	$('#idcliente').selectpicker('refresh');
   });

    //cargamos los tipos de pagos
	$.post("controladores/formapagosControlador.php?op=selectformapagoc", function(r){
		$("#modo_pago").html(r);
		$("#modo_pago").val(0);
		$('#modo_pago').selectpicker('refresh');
	});


}

//funcion limpiar
function limpiar(){
	$('#formulario').data('bootstrapValidator').resetForm(true);
	document.getElementById("formaguardarcliente").reset();
	$("#detalles").html("");
	$("#detalles").html(r);
	$("#tipo_documento").val("");
	$("#num_documento").val("");
	$("#nombre").val("");
	$("#tipo_comprobante").val("");
	$("#serie_comprobante").val("");
	$("#num_comprobante").val("");
	$("#impuesto").val("");
	$('#montosubtotal').val(0);
	$('#montoapagarbs').val(0);
	$('#validar').val(0);
	$("#total_venta").val(0);
	$("#total_venta1").val(0);
	$(".filas").remove();
	$("#total").html("0");
	$("#idtransportista").val("");
	$("#idtransportista").selectpicker('refresh');
	$("#idcliente").val("");
	$("#idcliente").selectpicker('refresh');
	buscarTasaDeCambio();
	

	//obtenemos la fecha actual
	var now 	= 	new Date();
  var today = 	new Date();
	var dd 		=	("0"+now.getDate()).slice(-2);
  var mm		=	("0"+(now.getMonth()+1)).slice(-2);
  var yyyy  =   now.getFullYear();
	var today	=	yyyy+'-'+mm+'-'+dd;
	$(fecha_hora).val(today);

	//marcamos el primer tipo_documento
	$("#tipo_comprobante").val("Factura");
	$("#tipo_comprobante").selectpicker('refresh');
	marcarImpuesto();

	//marcamos el primer tipo_documento
	$("#tipo_documento").val("CEDULA");
	$("#tipo_documento").selectpicker('refresh');
}

function limpiarsolocliente() {
	$("#tipo_documento1").val("");
    $("#num_documento1").val("");
    $("#nombre1").val("");
    $("direccion1").val("");
    $("telefono1").val("");
    $("Email").val("");
    $("email1").val("");
}

//funcion mostrar formulario
function mostrarform(flag){
	limpiar();
	if(flag){
		$("#listadoregistros").hide();
		$("#formularioregistros").show();
		$("#formularioregistros1").show();
		//$("#btnGuardar").prop("disabled",false);
		$("#btnagregar").hide();
		//listarArticulos();
		//listarArticulosb();
		//listarArticulosc();
		//listarPedidos();
		listarServicios();
		buscarNroFacturaControl();
		buscarTasaDeCambio();
			
		$("#btnGuardar").hide();
		$("#btnCancelar").show();
		detalles=0;
		$("#btnAgregarArt").show();
		$("#btnAgregarPed").hide();
		$("#btnAgregarArtb").hide();
		$("#btnAgregarArtc").hide();
		$("#btnAgregarSer").show();
		$("#cod_barra").val("");
		$("#cod_barra").focus();

	}else{
		$("#listadoregistros").show();
		$("#formularioregistros").hide();
		$("#formularioregistros1").hide();
		$("#btnagregar").show();
	}
}

//Se busca el numero la tasa de cambio
function buscarTasaDeCambio(){
	idempresa_venta=$("#idempresa_venta").val();
	//alert ('idempresa_venta: '+idempresa_venta);
	$.post("controladores/empresaControlador.php?op=buscarTasaDeCambio",{idempresa_venta : idempresa_venta},
		function(data,status)
		{
			//alert ('estatus: '+status);
			data1=JSON.parse(data);
			//console.log('tasa de cambiobd: '+data1.tasa_dollar);
			//$("#tasa_dollar").val(number_format(data1.tasa_dollar),2);
			$("#tasa_dollar").val(data1.tasa_dollar);
			//console.log('tasa de cambio:'+$("#tasa_dollar").val());
			//$("#tasa_euro").val(number_format(data1.tasa_euro),2);
			$("#tasa_euro").val(data1.tasa_euro);
	//		alert ('Control: '+data1.nrocontrol+' Factura: '+data1.nrofactura);
		});
}


//cancelar form
function cancelarform(){
	limpiar();
	mostrarform(false);
}

function marcarImpuesto(){
	var tipo_comprobante=$("#tipo_comprobante option:selected").text();
	var impuestotexto 						= document.getElementById("impuesto");
	impuestotexto.style.backgroundColor 	= "#D5D5CE";
	if (tipo_comprobante=='Factura') {
		$("#impuesto").val(impuesto);
	}else{
		$("#impuesto").val("0");
	}
	
}

// funcion para buscar el cliente
function buscarcliente(tipo_documento,num_documento) {
	var tipo_documento11 = tipo_documento;
	var num_documento11	= num_documento;
	//alert ('tipo y numero: '+ tipo_documento11+ ' '+num_documento11);
	$.ajax({
		url: 'controladores/personaControlador.php?op=buscarcliente',
		method: 'post',
		data: {
			tipo_documento : tipo_documento11,
			num_documento : num_documento11
		},
		})
		.done(function(datos) {
		/* Depuramos los datos recibidos */
		datos=JSON.parse(datos);
		console.log( datos );
		/* Se verifica si se delvovio algun resultado */
		if ((datos == null)||(datos == "undefined")) {
			/* hacer algo */
			bootbox.confirm("El cliente no existe necesita crearlo", function(result){
				if (result) {
					$("#tipo_documento1").val(tipo_documento11);
					$("#tipo_documento1").selectpicker('refresh');
					tipo_documento1.style.backgroundColor 	= "#D5D5CE";
					$("#num_documento1").val(num_documento11);
					num_documento1.style.backgroundColor 	= "#D5D5CE";
					$('#myModalCliente').modal('show');
				}
			})
			return;
		}
		/* Colocamos los datos del cliente */
		//$("#nombre_cliente").val(datos.nombre);
				
		//nombre_cliente.style.backgroundColor 	= "#D5D5CE";
		//$('#formulario').bootstrapValidator('false');
		//alert ('nombre y id: '+ datos.nombre+ '--'+datos.idpersona);
		$("#idcliente").val(datos.idpersona);
		$("#idcliente").selectpicker('refresh');
		verificarlistaprecio(datos.idlistaprecio);
		})
		.fail(function() {
			alert( "Error" );
		})
		.always(function() {
		/* Seleccionamos el texto para que se pueda sobreescribir por la siguiente lectura */
		$("input[name='cod_barra']").select();
		});

}

// funcion para buscar el cliente
function buscarclienteid(idcliente) {
	var idpaciente = idcliente;
	//alert ('tipo y numero: '+ tipo_documento11+ ' '+num_documento11);
	$.ajax({
		url: 'controladores/pacienteControlador.php?op=buscarclienteid',
		method: 'post',
		data: {
			idpaciente : idpaciente
		},
		})
		.done(function(datos) {
		/* Depuramos los datos recibidos */
		datos=JSON.parse(datos);
		console.log( datos );
		/* Se verifica si se delvovio algun resultado */
		if ((datos == null)||(datos == "undefined")) {
			/* hacer algo */
			bootbox.confirm("El cliente no existe necesita crearlo", function(result){
				if (result) {
					$("#tipo_documento1").val(tipo_documento11);
					$("#tipo_documento1").selectpicker('refresh');
					tipo_documento1.style.backgroundColor 	= "#D5D5CE";
					$("#num_documento1").val(num_documento11);
					num_documento1.style.backgroundColor 	= "#D5D5CE";
					$('#myModalCliente').modal('show');
				}
			})
			return;
		}
		/* Colocamos los datos del cliente */
		//$("#nombre_cliente").val(datos.nombre);
				
		//nombre_cliente.style.backgroundColor 	= "#D5D5CE";
		//$('#formulario').bootstrapValidator('false');
		//alert ('nombre y id: '+ datos.nombre+ '--'+datos.idpersona);
		$("#num_documento").val(datos.ci);
		$("#tipo_documento").val('CEDULA');
        $("#tipo_documento").selectpicker('refresh');
        listarCitas(datos.idpaciente);
		//verificarlistaprecio(datos.idlistaprecio);
		})
		.fail(function() {
			alert( "Error" );
		})
		.always(function() {
		/* Seleccionamos el texto para que se pueda sobreescribir por la siguiente lectura */
		$("input[name='cod_barra']").select();
		});

}

// funcion para buscar el despacho
function buscardespachoid(idcliente) {
	var idpersona = idcliente;
	$.post("controladores/personaControlador.php?op=buscardespachoid", {idpersona : idpersona}, function(r){
		$("#idclientedespacho").html(r);
   		$('#idclientedespacho').selectpicker('refresh');
	});   
}

function buscarcodigodebarra(codbarra){
	//alert ('buscando codigo de barra: '+codbarra);
	$.ajax({
		url: 'complemento/leercodigobarra.php',
		method: 'post',
		data: {
			codigobarra: codbarra,
		},
		})
		.done(function(datos) {
		/* Depuramos los datos recibidos */
		console.log( datos );
		/* Si no se devolvió ningún registro (false) debería hacerse algo */
		if (datos === false) {
			/* hacer algo */
			//bootbox.alert('No se encontró el código de barras');
			//Ahora buscamos en la tarjeta de cliente
			buscarcodigodebarratarjetapendiente(codbarra)
			$("#cod_barra").val("");
			$("#cod_barra").focus(); 
			return;
		}
		/* Agregamos una fila con los datos obtenidos */
		   agregarDetalle(datos.idarticulo,datos.nombre,datos.precio,datos.porcentaje,datos.numerolote,datos.fecha);
		})
		.fail(function() {
			alert( "Error" );
		})
		.always(function() {
		/* Seleccionamos el texto para que se pueda sobreescribir por la siguiente lectura */
		$("input[name='cod_barra']").select();
		});
}

/* Codigo para habilitar y dar permiso para modificar precio, cantidad, descuento y precio */
/*******                                                                                   */
function buscarClave(){
	logina=$("#usuariopermiso").val();
	clavea=$("#clavepermiso").val();
	console.log(logina,clavea);
    $.post("controladores/usuarioControlador.php?op=verificarpermiso",
    {"logina":logina, "clavea":clavea},
    function(data)
    {
	    console.log(data);
        if (data==1){
			$("#usuariopermiso").val("");
			$("#clavepermiso").val("");
			
			$('#myModalPermiso').modal('hide');
			fcampoacambiar();
        }else{
            swal(
                'Error inesperado',
                'El Usuario y/o Password son incorrectos',
                'error'
            ); 
        }
	})
}

function fcampoacambiar() {
	var campo 		= $("#campoacambiar").val();
	var indice		= $("#indice").val();
	var preciod		= document.getElementsByName("precio_ventad[]");
	var cantidad	= document.getElementsByName("cantidad[]");
	var porcentaje	= document.getElementsByName("porcentaje[]");
	var descuento	= document.getElementsByName("descuentod[]");
	$("#controlpermisop").val(0);
	$("#controlpermisoc").val(0);
	$("#controlpermisopo").val(0);
	$("#controlpermisod").val(0);
	if (campo=='precio'){
		preciod[indice].style.background = "#84fa64";
		preciod[indice].readOnly = false;
		$("#controlpermisop").val(1);
	}
	if (campo=='cantidad'){
		cantidad[indice].style.background = "#84fa64";
		cantidad[indice].readOnly = false;
		$("#controlpermisoc").val(1);
	}
	if (campo=='porcentaje'){
		porcentaje[indice].style.background = "#84fa64";
		porcentaje[indice].readOnly = false;
		$("#controlpermisopo").val(1);
	}
	if (campo=='descuento'){
		descuento[indice].style.background = "#84fa64";
		descuento[indice].readOnly = false;
		$("#controlpermisod").val(1);
	}
}

function buscarindice(indice) {
	var posi		=	document.getElementsByName("posicion[]");
	var indice1		=	0;
	for (var i = 0; i < posi.length; i++) {
		var pos	=	posi[i];
		if (pos.value==indice){
			indice1=i;
			break;
		}
	}	
	return indice1;
}

function cambiarprecio(indice) {
	var indice1 = buscarindice(indice);
	if ($("#controlpermisop").val()==0){
		$("#indice").val(indice1);
		$("#campoacambiar").val("precio");
		$('#myModalPermiso').modal('show');
	}
	console.log('indice fila: '+indice);
	console.log('indice correcto :'+indice1);
}

function cambiarcantidad(indice) {
	var indice1 = buscarindice(indice);
	if ($("#controlpermisoc").val()==0){
		$("#indice").val(indice1);
		$("#campoacambiar").val("cantidad");
		$('#myModalPermiso').modal('show');
	}
	console.log('indice fila: '+indice);
	console.log('indice correcto :'+indice1);
}

function cambiarporcentaje(indice) {
	var indice1 = buscarindice(indice);
	if ($("#controlpermisopo").val()==0){
		$("#indice").val(indice1);
		$("#campoacambiar").val("porcentaje");
		$('#myModalPermiso').modal('show');
	}
	console.log('indice fila: '+indice);
	console.log('indice correcto :'+indice1);
}

function cambiardescuento(indice) {
	var indice1 = buscarindice(indice);
	if ($("#controlpermisod").val()==0){
		$("#indice").val(indice1);
		$("#campoacambiar").val("descuento");
		$('#myModalPermiso').modal('show');
	}
	console.log('indice fila: '+indice);
	console.log('indice correcto :'+indice1);
}

/*  fin de codigo de */


//Se busca el numero de factura y control
function buscarNroFacturaControl(){
	idempresa_venta=$("#idempresa_venta").val();
	var serie_comprobante 		= document.getElementById("serie_comprobante");
	var num_comprobante 		= document.getElementById("num_comprobante");
//	alert ('idempresa_venta: '+idempresa_venta);
	$.post("controladores/empresaControlador.php?op=buscarNroFacturaControl",{idempresa_venta : idempresa_venta},
		function(data,status)
		{
			//alert ('estatus: '+status);
			data1=JSON.parse(data);
			$("#serie_comprobante").val(data1.nrocontrol);
			serie_comprobante.style.backgroundColor 	= "#D5D5CE";
			$("#num_comprobante").val(data1.nrofactura);
			num_comprobante.style.backgroundColor 		= "#D5D5CE";
	//		alert ('Control: '+data1.nrocontrol+' Factura: '+data1.nrofactura);
		});
}

//Se habilita la lista de precio para el cliente seleccionado
function verificarlistaprecio(idlistaprecio) {
	if (idlistaprecio==1){
		$("#btnAgregarArt").show();
		$("#btnAgregarArtb").hide();
		$("#btnAgregarArtc").hide();
	}
	else if (idlistaprecio==2){
		$("#btnAgregarArt").hide();
		$("#btnAgregarArtb").show();
		$("#btnAgregarArtc").hide();
	}else{
		$("#btnAgregarArt").hide();
		$("#btnAgregarArtb").hide();
		$("#btnAgregarArtc").show();
	}
}

//funcion listar
function listar(){
	tabla=$('#tbllistado').dataTable({
		"aProcessing": true,//activamos el procedimiento del datatable
		"aServerSide": true,//paginacion y filrado realizados por el server
		dom: 'Bfrtip',//definimos los elementos del control de la tabla
		buttons: [
                  'copyHtml5',
                  'excelHtml5',
                  'csvHtml5',
                  'pdf'
		],
		"ajax":
		{
			url:'controladores/ventanControlador.php?op=listarf',
			type: "get",
			dataType : "json",
			error:function(e){
				console.log(e.responseText);
			}
		},
		"bDestroy":true,
		"iDisplayLength":-1,//paginacion
		"order":[[0,"desc"]]//ordenar (columna, orden)
	}).DataTable();
}

function listarCitas(idpaciente){
	tabla=$('#tblarticuloscitas').dataTable({
		"aProcessing": true,//activamos el procedimiento del datatable
		"aServerSide": true,//paginacion y filrado realizados por el server
		dom: 'Bfrtip',//definimos los elementos del control de la tabla
		buttons: [

		],
		"ajax":
		{
			url:'controladores/citaControlador.php?op=listarCitas',
            type: "get",
            dataType : "json",
            method: 'post',
		    data: {
			    idpaciente : idpaciente
		    },
			error:function(e){
				console.log(e.responseText);
			}
		},
		"bDestroy":true,
		"iDisplayLength":-1,//paginacion
		"order":[[0,"desc"]]//ordenar (columna, orden)
	}).DataTable();
}

function listarArticulos(){
	tabla=$('#tblarticulos').dataTable({
		"aProcessing": true,//activamos el procedimiento del datatable
		"aServerSide": true,//paginacion y filrado realizados por el server
		dom: 'Bfrtip',//definimos los elementos del control de la tabla
		buttons: [

		],
		"ajax":
		{
			url:'controladores/ventanControlador.php?op=listarArticulos',
			type: "get",
			dataType : "json",
			error:function(e){
				console.log(e.responseText);
			}
		},
		"bDestroy":true,
		"iDisplayLength":-1,//paginacion
		"order":[[0,"desc"]]//ordenar (columna, orden)
	}).DataTable();
}

function listarArticulosb(){
	tabla=$('#tblarticulosb').dataTable({
		"aProcessing": true,//activamos el procedimiento del datatable
		"aServerSide": true,//paginacion y filrado realizados por el server
		dom: 'Bfrtip',//definimos los elementos del control de la tabla
		buttons: [

		],
		"ajax":
		{
			url:'controladores/ventanControlador.php?op=listarArticulosb',
			type: "get",
			dataType : "json",
			error:function(e){
				console.log(e.responseText);
			}
		},
		"bDestroy":true,
		"iDisplayLength":-1,//paginacion
		"order":[[0,"desc"]]//ordenar (columna, orden)
	}).DataTable();
}

function listarArticulosc(){
	tabla=$('#tblarticulosc').dataTable({
		"aProcessing": true,//activamos el procedimiento del datatable
		"aServerSide": true,//paginacion y filrado realizados por el server
		dom: 'Bfrtip',//definimos los elementos del control de la tabla
		buttons: [

		],
		"ajax":
		{
			url:'controladores/ventanControlador.php?op=listarArticulosc',
			type: "get",
			dataType : "json",
			error:function(e){
				console.log(e.responseText);
			}
		},
		"bDestroy":true,
		"iDisplayLength":-1,//paginacion
		"order":[[0,"desc"]]//ordenar (columna, orden)
	}).DataTable();
}

function listarServicios(){
	tabla=$('#tblservicios').dataTable({
		"aProcessing": true,//activamos el procedimiento del datatable
		"aServerSide": true,//paginacion y filrado realizados por el server
		dom: 'Bfrtip',//definimos los elementos del control de la tabla
		buttons: [

		],
		"ajax":
		{
			url:'controladores/ventanControlador.php?op=listarServicios',
			type: "get",
			dataType : "json",
			error:function(e){
				console.log(e.responseText);
			}
		},
		"bDestroy":true,
		"iDisplayLength":-1,//paginacion
		"order":[[0,"desc"]]//ordenar (columna, orden)
	}).DataTable();
}

function listarPedidos(){
	tabla=$('#tblpedidos').dataTable({
		"aProcessing": true,//activamos el procedimiento del datatable
		"aServerSide": true,//paginacion y filrado realizados por el server
		dom: 'Bfrtip',//definimos los elementos del control de la tabla
		buttons: [

		],
		"ajax":
		{
			url:'controladores/pedidoControlador.php?op=listarPedido',
			type: "get",
			dataType : "json",
			error:function(e){
				console.log(e.responseText);
			}
		},
		"bDestroy":true,
		"iDisplayLength":-1,//paginacion
		"order":[[0,"desc"]]//ordenar (columna, orden)
	}).DataTable();
}


function guardarcliente() {
	
	var formDataCliente=new FormData($("#formaguardarcliente")[0]);
	var tipo_documento1 = $("#tipo_documento1").val();
	var num_documento1	= $("#num_documento1").val();
	//alert('ahora vamos aguardar el cliente tipo documento y nro ' + tipo_documento1+' -- '+num_documento1);
	$.ajax({
		url: "controladores/personaclienteControlador.php?op=guardaryeditar",
		type: "POST",
		data: formDataCliente,
		contentType: false,
		processData: false,
		success: function(datos){
			bootbox.alert(datos);
			buscarcliente(tipo_documento1,num_documento1);
		}
	});
	limpiarsolocliente();
}


//funcion para guardaryeditar
function guardaryeditar(){
     //e.preventDefault();//no se activara la accion predeterminada 
     //$("#btnGuardar").prop("disabled",true);
     var formData=new FormData($("#formulario")[0]);

     $.ajax({
     	url: "controladores/ventanControlador.php?op=guardaryeditarcita",
     	type: "POST",
     	data: formData,
     	contentType: false,
     	processData: false,

     	success: function(datos){
     		bootbox.alert(datos);
     		mostrarform(false);
     		listar();
     	}
     });

     limpiar();
}

function mostrar(idventa){
	$.post("controladores/ventanControlador.php?op=mostrar",{idventa : idventa},
		function(data,status)
		{
			data=JSON.parse(data);
			mostrarform(true);

			$("#idcliente").val(data.idcliente);
			$("#num_documento").val(data.num_documento);
			$("#nombre_cliente").val(data.cliente);
			$("#tipo_comprobante").val(data.tipo_comprobante);
			$("#tipo_comprobante").selectpicker('refresh');
			$("#serie_comprobante").val(data.serie_comprobante);
			$("#num_comprobante").val(data.num_comprobante);
			$("#fecha_hora").val(data.fecha);
			$("#impuesto").val(data.impuesto);
			$("#idventa").val(data.idventa);
			$("#idtransportista").val(data.idtransportista);
			$("#idtransportista").selectpicker('refresh');
			
			//ocultar y mostrar los botones
			$("#btnGuardar").hide();
			$("#btnCancelar").show();
			$("#btnAgregarArt").hide();
			$("#btnAgregarSer").hide();
			$("#btnTotalizar").hide();
			$("#btnAgregarBar").hide();
			
		});
	$.post("controladores/ventanControlador.php?op=listarDetalle&id="+idventa,function(r){
		$("#detalles").html(r);
	});

}

//funcion para Anular una factura
function anular(idventa,idusuario){
	bootbox.confirm("¿Esta seguro de Anular esta factura?", function(result){
		if (result) {
			console.log('idventa y idusuario: '+idventa+'--'+idusuario);
			$.post("controladores/devolucionControlador.php?op=anular", {idventa : idventa, idusuario : idusuario}, function(e){
				bootbox.alert(e);
				tabla.ajax.reload();
			});
		}
	})
}

//       agregarDetalle(idarticulo,idalmacen,articulo,precio_venta,precio_ventad,porcentaje,nrolote,fechalote,exento,impuestoart18,impuestoart18d,preciopvp,preciopvpd)
function agregarDetalle(idarticulo,idalmacen,articulo,precio_venta,precio_ventad,porcentaje,nrolote,fechalote,fechacita,exento,impuestoart18,impuestoart18d,preciopvp,preciopvpd,idcita){
	var cantidad		=	1;
	var descuento		=	0;
	var descuentod		=	0;
	var impoart18		=	impuestoart18;
	var impoart18d		=	impuestoart18d;
	var idpedido		=	idcita;
	var imp18_empresa	=	$('#impuestoart18_empresa').val();
	var tasadollar		=	$("#tasa_dollar").val();
	console.log('Inicio de agregar producto o servicio');
	if (idarticulo!="") {
		var iva 			= 0;
		var ivad 			= 0;
		var subtotal		= 0;
		var subtotalsiniva	= 0;
		var exentot			= 0;
		var precio 			= 0;
		var preciod 		= 0;
		var salida 			= convertDateFormat(fechalote);
		var fechalotef		= convertDateLote(fechalote);
		precio_venta 		= precio_ventad*tasadollar;
		preciopvp			= preciopvpd*tasadollar;
		if (fechalote=='N/A'){
			fechalotef	= fechalote;
		}
		console.log('exento: '+exento);
		if (exento=='si'){
			precio 		= precio_venta*1;
			preciod 	= precio_ventad*1;
			exentot		= precio_venta*1;
			exentotd	= precio_ventad*1;
			if (precio==0){
				exentot		=1;
				exentotd	=1;
			}
			
			articulo 	= articulo + '';
            iva			= 0;
            ivad		= 0;
		}else{
			iva			= (precio_venta*impuesto)/100;
			ivad		= (precio_ventad*impuesto)/100;
			precio		= precio_venta*1;
			preciod 	= precio_ventad*1;
			exentot		= 0;
			exentotd	= 0;
		}
		if (imp18_empresa=='si'){
			td			=	'<td><input type="text" name="impoart18d[]" id="impoart18d[]" style="text-align:right;width:120px" value="'+number_format(impoart18d,2)+'" >'+
							'<input type="hidden" name="impoart18[]" id="impoart18[]" value="'+number_format(impoart18,2)+'" ></td>';
			td1			=	'<td><input type="text" name="precio_ventapvpd[]" id="precio_ventapvpd[]" style="text-align:right;width:120px" value="'+number_format(preciopvpd,2)+'"></td>';
		}else{
			td			=	'<input type="hidden" name="impoart18[]" id="impoart18[]" value="'+number_format(impoart18,2)+'">'+
							'<input type="hidden" name="impoart18d[]" id="impoart18d[]" value="'+number_format(impoart18d,2)+'">';
			td1			=	'<input type="hidden" name="precio_ventapvpd[]" id="precio_ventapvpd[]" value="'+number_format(preciopvpd,2)+'">';
		}
		console.log('nrolote: '+nrolote);
		if (fechacita!='N/A'){
			articulo		=	articulo+' Del: '+fechacita;
		}
       	subtotalsiniva	= cantidad*precio_venta;
		subtotal		= cantidad*precio;
		subtotald		= cantidad*preciod;
		console.log('fecha: '+salida+'precio: '+precio+'exentot: '+exentot);
		var fila='<tr class="filas" id="fila'+cont+'">'+
        '<td><button type="button" class="btn btn-danger" onclick="eliminarDetalle('+cont+')">X</button></td>'+
		'<td><input type="hidden" name="idarticulo[]" value="'+idarticulo+'">'+articulo+'</td>'+
		'<td><input type="text" name="cantidad[]" id="cantidad[]"  onclick="cambiarcantidad('+cont1+')" style="text-align:right;width:80px;background-color:#D5D5CE" value="'+number_format(cantidad)+'" readonly></td>'+
		'<td><input type="text" name="precio_ventad[]" id="precio_ventad[]" onclick="cambiarprecio('+cont1+')" style="text-align:right;width:120px;background-color:#D5D5CE" value="'+number_format(preciod,2)+'" readonly></td>'+
		td1+
		'<td><input type="text" name="porcentaje[]" id="porcentaje[]" onclick="cambiarporcentaje('+cont1+')" style="text-align:right;width:70px;background-color:#D5D5CE" value="'+number_format(porcentaje,2)+'" readonly></td>'+
		'<td><input type="text" name="descuentod[]" id="descuentod[]" onclick="cambiardescuento('+cont1+')" style="text-align:right;width:120px;background-color:#D5D5CE" value="'+number_format(descuentod,2)+'"readonly ></td>'+
		td+
		'<td><input type="text" style="text-align:right;width:120px" name="subtotald[]" id="subtotald[]"  value="'+number_format(subtotald,2)+'" readonly></td>'+
        //'<td><span id="subtotal'+cont+'" name="subtotal">'+subtotal+'</span></td>'+
		'<td><button type="button" onclick="modificarSubtotales()" class="btn btn-info"><i class="fa fa-refresh"></i></button>'+
		'<input type="hidden" name="nrolote[]" value="'+nrolote+'">'+
		'<input type="hidden" name="idpedidosolo[]" id="idpedidosolo[]" value="'+(idpedido*1)+'">'+
		'<input type="hidden" name="idalmacen[]" id="idalmacen[]" value="'+idalmacen+'">'+
		'<input type="hidden" name="iva[]" value="'+iva+'">'+
		'<input type="hidden" name="ivad[]" value="'+ivad+'">'+
		'<input type="hidden" name="exentot[]" value="'+exentot+'">'+
		'<input type="hidden" name="exentotd[]" value="'+exentotd+'">'+
		'<input type="hidden" name="precio_venta[]" id="precio_venta[]" value="'+number_format(precio,2)+'">'+
		'<input type="hidden" name="subtotal[]" id="subtotal[]"  value="'+number_format(subtotal,2)+'">'+
		'<input type="hidden" name="precio_ventapvp[]" id="precio_ventapvp[]" value="'+number_format(preciopvp,2)+'">'+
		'<input type="hidden" name="descuento[]" id="descuento[]" value="'+number_format(descuento,2)+'" >'+
		'<input type="hidden" name="posicion[]" id="posicion[]" value="'+cont1+'" >'+
		'</td>'+
		'</tr>';
		cont1++;
		cont++;
		detalles++;
		$('#detalles').append(fila);
		modificarSubtotales();

	}else{
		alert("error al ingresar el detalle, revisar las datos del articulo ");
	}
	console.log('Fin de agregar producto o servicio');
}

function agregarDetallePedido(idpedido){
	if(verificarpedido(idpedido)){
		$.post("controladores/pedidoControlador.php?op=agregarDetallePedido&id="+idpedido+"&cont="+cont,function(r){
			$('#detalles').append(r);
			//calculamos la cantidad de articulos que agregaron
			var idart	=	document.getElementsByName("idarticulo[]");
			var nroar	=	idart.length;
			detalles	=	nroar;
			cont		= 	(cont + nroar);
			modificarSubtotales();
			
		//	$("#detalles").html(r);
		});
	}else{
		bootbox.alert('Ya agrego esta tarjeta');
	}
}

function verificarpedido(idpedido) {
	var idpedidos=document.getElementsByName("idpedidosolo[]");
	resultado = true;
	if (idpedidos.length>0) {
		for (var i = 0; i < idpedidos.length; i++) {
			var pedido		=	idpedidos[i];
			var pedidov		=	pedido.value;
			var pedidot		=	pedidov.replace(/[^0-9\,-]/g, ''); // elimino cualquier cosa que no sea numero o coma
			pedidot			=	pedidot.split(',');
			var idpedido1	=	pedidot[2];
			if (idpedido1==idpedido){
				resultado = false;
				break;
			}
		}
	}
	return resultado;	
}

function modificarValoresAnumerico(){
	var cant	=	document.getElementsByName("cantidad[]");
	var prev	=	document.getElementsByName("precio_venta[]");
	var desc	=	document.getElementsByName("descuento[]");
	var porc	=	document.getElementsByName("porcentaje[]");
	var sub		=	document.getElementsByName("subtotal[]");
	var exe		=	document.getElementsByName("exentot[]");
	var a18		=	document.getElementsByName("impoart18[]");
	var pvp		=	document.getElementsByName("precio_ventapvp[]");
	var tasa	=	$("#tasa_dollar").val();
	
	//$("#tasa_dollar").val(numero(tasa));

	for (var i = 0; i < cant.length; i++) {
		var Cmod	=	cant[i];
		var Pvmod	=	prev[i];
		var Dmod	=	desc[i];
		var Ia18	=	a18[i];
		var Pmod	=	porc[i];
		var Smod	=	sub[i];
		var Pvpd	=	pvp[i];
		Cmod.value	=	numero(Cmod.value);
		Dmod.value	=	numero(Dmod.value);
		Ia18.value	=	numero(Ia18.value);
		Pvmod.value	=	numero(Pvmod.value);
		Pmod.value	=	numero(Pmod.value);
		Smod.value	=	numero(Smod.value);
		Pvpd.value	=	numero(Pvpd.value);
	}

};


function modificarSubtotalesold(boton){
	var idart		=	document.getElementsByName("idarticulo[]");
	var cant		=	document.getElementsByName("cantidad[]");
	var prev		=	document.getElementsByName("precio_venta[]");
	var desc		=	document.getElementsByName("descuento[]");
	var art8		=	document.getElementsByName("impoart18[]");
	var porc		=	document.getElementsByName("porcentaje[]");
	var sub			=	document.getElementsByName("subtotal[]");
	var subd		=	document.getElementsByName("subtotald[]");
	var ivao		=	document.getElementsByName("iva[]");
	var exet		=	document.getElementsByName("exentot[]");
	var impart18emp =	$("#impuestoart18_empresa").val();

	for (var i = 0; i < cant.length; i++) {
		var inpV			=	cant[i];
		var inpP			=	prev[i];
		var inpS			=	sub[i];
		var des				=	desc[i];
		var iart18			=	art8[i];
		var por				=	porc[i];
		var subt			=	sub[i];
		var ivat 			=	ivao[i];
		var exento 			=	exet[i];	
		var	imp 			= 	1+(impuesto/100);
		var precio			=	numero(inpP.value*imp);
		var precioSiva 		= 	numero(inpP.value);
		var precioNew		=	0;
		var precioNewCiva 	= 	0;
		var ivaNew			=	0;
		var porT			=	0;
		var total 			=	0;	

		console.log('impuesto'+imp);
		console.log('precio: '+precio);
		console.log('Precio sin iva: '+precioSiva);
		if (numero(por.value)>0){
			if (numero(inpP.value)>0){
				porT			= (precioSiva*numero(por.value))/100;
				console.log('MontoPorcentaje: '+porT);
				precioNew		= precioSiva - porT;
				ivaNew			= (precioNew*impuesto)/100;
				precioNewCiva	= precioNew + ivaNew;
				if (impart18emp=='si'){
					inpS.value		= ((numero(inpV.value)*precioNew)+(numero(inpV.value)*numero(iart18.value))-numero(des.value));
				}else{
					inpS.value		= (numero(inpV.value)*precioNew)-numero(des.value);
				}

				console.log('precioNuevo: '+precioNew+' IvaNuevo:'+ivaNew);
				console.log('subtotal nuevo: '+inpS.value);
			}else{
				total 		= Totales();
				console.log('Total: '+total)
				porT		= (total*numero(por.value))/100;
				ivaNew		= (porT*impuesto)/100;
				inpS.value	= porT;
				//inpS.value=1000;
			}
			if (exento.value==0){
				ivat.value	= number_format(ivaNew,2);
			}else{
				ivaNew		= 0;
				ivat.value	= number_format(ivaNew,2);
			}
		}else{
			
			inpS.value		=	((numero(inpV.value)*numero(inpP.value))+(numero(inpV.value)*numero(iart18.value))-numero(des.value));

		}
		//document.getElementsByName("subtotal")[i].innerHTML=number_format(inpS.value,2);
		subt.value = number_format(inpS.value,2);
	}
	calcularTotales(boton);
}

function modificarSubtotales(boton){
	var idart		=	document.getElementsByName("idarticulo[]");
	var cant		=	document.getElementsByName("cantidad[]");
	var prev		=	document.getElementsByName("precio_venta[]");
	var prevd		=	document.getElementsByName("precio_ventad[]");
	var desc		=	document.getElementsByName("descuento[]");
	var descd		=	document.getElementsByName("descuentod[]");
	var art8		=	document.getElementsByName("impoart18[]");
	var art8d		=	document.getElementsByName("impoart18d[]");
	var porc		=	document.getElementsByName("porcentaje[]");
	var sub			=	document.getElementsByName("subtotal[]");
	var subd		=	document.getElementsByName("subtotald[]");
	var ivao		=	document.getElementsByName("iva[]");
	var ivaod		=	document.getElementsByName("ivad[]");
	var exet		=	document.getElementsByName("exentot[]");
	var exetd		=	document.getElementsByName("exentotd[]");
	var impart18emp =	$("#impuestoart18_empresa").val();
	var tasadollar	=	$("#tasa_dollar").val();
	console.log('inicio subtotal')
	for (var i = 0; i < cant.length; i++) {
		var inpV			=	cant[i];
		var inpP			=	prev[i];
		var inpPd			=	prevd[i];
		var inpS			=	sub[i];
		var inpSd			=	subd[i];
		var des				=	desc[i];
		var desd			=	descd[i];
		var iart18			=	art8[i];
		var iart18d			=	art8d[i];
		var por				=	porc[i];
		var subt			=	sub[i];
		var subtd			=	subd[i];
		var ivat 			=	ivao[i];
		var ivatd 			=	ivaod[i];
		var exento 			=	exet[i];
		var exentod 		=	exetd[i];	
		var	imp 			= 	1+(impuesto/100);
		//*tasadollar*imp
		var precio			=	numero(inpPd.value)*tasadollar*imp;
		var preciod			=	numero(inpPd.value)*imp;
		var precioSiva 		= 	numero(inpPd.value)*tasadollar;
		var precioSivad		= 	numero(inpPd.value);
		var precioNew		=	0;
		var precioNewd		=	0;
		var precioNewCiva 	= 	0;
		var precioNewCivad 	= 	0;
		var ivaNew			=	0;
		var ivaNewd			=	0;
		var porT			=	0;
		var porTd			=	0;
		var total 			=	0;
		var totald 			=	0;	

		console.log('impuesto'+imp);
		console.log('precio: '+precio);
		console.log('Precio sin iva: '+precioSiva);
		console.log('precio $: '+preciod);
		console.log('Precio sin iva $: '+precioSivad);
		//Verificamos si hay un descuento o incremento
		if (numero(por.value)>0){
			//Verificamos si el descuento o incremento es sobre el producto o servicios
			if (numero(inpP.value)>0){
				porT			= (precioSiva*numero(por.value))/100;
				porTd			= (precioSivad*numero(por.value))/100;
				console.log('MontoPorcentaje: '+porT);
				console.log('MontoPorcentaje $: '+porTd);
				precioNew		= precioSiva - porT;
				precioNewd		= precioSivad - porTd;
				console.log('precioNew: '+precioNew);
				console.log('precioNew $: '+precioNewd);
				ivaNew			= (precioNew*impuesto)/100;
				ivaNewd			= (precioNewd*impuesto)/100;
				console.log('ivaNew: '+precioNew);
				console.log('ivaNewd: '+precioNewd);
				precioNewCiva	= precioNew + ivaNew;
				precioNewCivad	= precioNewd + ivaNewd;
				if (impart18emp=='si'){
					inpS.value		= ((numero(inpV.value)*precioNew)+(numero(inpV.value)*numero(iart18.value))-(numero(desd.value)*tasadollar));
					inpSd.value		= ((numero(inpV.value)*precioNewd)+(numero(inpV.value)*numero(iart18d.value))-numero(desd.value));
				}else{
					inpS.value		= (numero(inpV.value)*precioNew)-(numero(desd.value)*tasadollar);
					inpSd.value		= (numero(inpV.value)*precioNewd)-numero(desd.value);
				}

				console.log('precioNuevo: '+precioNew+' IvaNuevo:'+ivaNew);
				console.log('subtotal nuevo: '+inpS.value);
			}else{
				total 		= Totales();
				totald 		= Totalesd();
				console.log('Inicio incremento o dsecuento');
				console.log('exento.value: '+exento.value);
				porT		= (total*numero(por.value))/100;
				porTd		= (totald*numero(por.value))/100;
				ivaNew		= (porT*impuesto)/100;
				ivaNewd		= (porTd*impuesto)/100;
				if (exento.value==0){

					ivat.value	= number_format(ivaNew,2);
					ivatd.value	= number_format(ivaNewd,2);
					
				}else{
					ivaNew			= 0;
					ivat.value		= number_format(ivaNew,2);
					ivatd.value		= number_format(ivaNew,2);
					exento.value	= number_format(porT,2);
					exentod.value	= number_format(porTd,2);
				}
				console.log('ivat.value: '+ivat.value);
				console.log('ivatd.value: '+ivatd.value);
				console.log('exento.value: '+exento.value);
				console.log('exentod.value: '+exentod.value);
				inpS.value	= porT;
				inpSd.value	= porTd;
				console.log('Fin incremento o dsecuento');
				//inpS.value=1000;
			}
			if (exento.value==0){
				ivat.value	= number_format(ivaNew,2);
				ivatd.value	= number_format(ivaNewd,2);
			}else{
				ivaNew		= 0;
				ivat.value	= number_format(ivaNew,2);
				ivatd.value	= number_format(ivaNew,2);
			}
		}else{
			
			inpS.value		=((numero(inpV.value)*precioSiva)+(numero(inpV.value)*numero(iart18.value))-(numero(desd.value)*tasadollar));
			inpSd.value		=((numero(inpV.value)*precioSivad)+(numero(inpV.value)*numero(iart18d.value))-numero(desd.value));
			
			console.log('subtotal bs: '+inpS.value);
			console.log('subtotal $: '+inpSd.value);
		}
		//document.getElementsByName("subtotal")[i].innerHTML=number_format(inpS.value,2);
		subt.value = number_format(inpS.value,2);
		subtd.value = number_format(inpSd.value,2);
	}
	console.log('fin de subtotal')
	calcularTotales(boton);
}


function calcularTotales(boton){
	//var sub 	= document.getElementsByName("subtotal");
	var sub			=	document.getElementsByName("subtotal[]");
	var subd			=	document.getElementsByName("subtotal[]");
	var iv			= 	document.getElementsByName("iva[]");
	var ivd			= 	document.getElementsByName("iva[]");
	var exento		=	document.getElementsByName("exentot[]");
	var exentod		=	document.getElementsByName("exentotd[]");
	var cant		=	document.getElementsByName("cantidad[]");
	var precio		=	document.getElementsByName("precio_venta[]");
	var preciod		=	document.getElementsByName("precio_ventad[]");
	var pvp			=	document.getElementsByName("precio_ventapvp[]");
	var pvpd		=	document.getElementsByName("precio_ventapvpd[]");
	var impart18emp =	$("#impuestoart18_empresa").val();
	var	imp 		= 	(impuesto/100);
	var total		= 0;
	var ivatt		= 0;
	var exentott	= 0;
	var totalconiva	= 0;
	var totalpvpiva	= 0;
	var difer_pre_pvp=0;
	//var tasadollar  = numero($("#tasa_dollar").val());
	var tasadollar  = $("#tasa_dollar").val();
	console.log('tasadollar: '+tasadollar)
	for (var i = 0; i < sub.length; i++) {
		var subt	=	sub[i];
		var subtd	=	subd[i];
		var ivat	=	iv[i];
		var ivatd	=	ivd[i];
		var exentot	=	exento[i];
		var exentotd=	exentod[i];
		var CanT	=	cant[i];
		var pvpt	=	pvp[i];
		var pvptd	=	pvpd[i];
		var precio1	=	precio[i];
		var preciod1=	precio[i];
		var pvptd1	=	numero(pvptd.value)*1;
		//total += document.getElementsByName("subtotal")[i].value;
        total 		+= 	numero(subt.value);
        if (ivat.value>0){
            ivatt  		+= 	numero(subt.value)*imp;
        }
		
		/* console.log('pvpt.value :'+pvpt.value);
		console.log('CanT.value :'+CanT.value);
		console.log('subt.value :'+subt.value);
		console.log('imp :'+imp);
		console.log('(numero(pvpt.value)*CanT.value: '+numero(pvpt.value)*CanT.value);
		console.log('numero(subt.value) :'+numero(subt.value)); */

		//Solo Para Daniel (JVG)
		//difer_pre_pvp=  (((numero(pvpt.value)*CanT.value))-numero(subt.value));
		difer_pre_pvp 	= (ivapercibido(numero(precio1.value)))*CanT.value;
		
		//console.log('difer_pre_pvp dollar :'+difer_pre_pvp);
		//console.log('difer_pre_pvp1 bs :'+difer_pre_pvp1);
		
		if (difer_pre_pvp<0){
			difer_pre_pvp = difer_pre_pvp*-1;
		}
		
		//Solo Para Daniel (JVG)
		//totalpvpiva +=	difer_pre_pvp*imp;
		totalpvpiva +=	difer_pre_pvp;

		console.log('totalpvpiva :'+totalpvpiva)
		exentott	+= 	(numero(exentot.value)*CanT.value);
	}
	console.log('impart18emp: '+impart18emp);
	if (impart18emp=='si'){
		totalconiva 	=	total + ivatt + totalpvpiva;
	}else{
		totalconiva 	=	total + ivatt;
	}
	
	
	$("#subtotal").html("Bs." + number_format(total,2));
	$("#subtotald").html("$." +number_format(total/tasadollar,2));	
	$("#iva").html("Bs." + number_format(ivatt,2));
	$("#ivad").html("$." +number_format(ivatt/tasadollar,2));
	$("#ivap").html("Bs." + number_format(totalpvpiva,2));
	$("#ivapd").html("$." +number_format(totalpvpiva/tasadollar,2));
	$("#exento").html("Bs." + number_format(exentott,2));
	$("#exentod").html("$." +number_format(exentott/tasadollar,2));
	$("#total").html("Bs." + number_format(totalconiva,2));
	$("#totald").html("$." + number_format(totalconiva/tasadollar,2));
	$("#total_venta1").val(total);
	$("#total_venta").val("");
	$("#total_venta").val(total);
	$("#total_ventad").val(total/tasadollar);
	$("#total_ventai").val(totalconiva);
	$("#total_ventaid").val(totalconiva/tasadollar);
	evaluar(boton);
}


function Totales(){
	//var sub 	= document.getElementsByName("subtotal");
	var sub		=	document.getElementsByName("subtotal[]");
	var prev	= 	document.getElementsByName("precio_venta[]");
	var total	= 	0.0;

	for (var i = 0; i < sub.length; i++) {
		if (numero(prev[i].value)>0){
			total += numero(sub[i].value);
		}
	}
	return total;
}

function Totalesd(){
	//var sub 	= document.getElementsByName("subtotal");
	var sub		=	document.getElementsByName("subtotald[]");
	var prev	= 	document.getElementsByName("precio_ventad[]");
	var total	= 	0.0;

	for (var i = 0; i < sub.length; i++) {
		if (numero(prev[i].value)>0){
			total += numero(sub[i].value);
		}
	}
	return total;
}

function evaluar(){
	$("#cod_barra").val("");
	$("#cod_barra").focus();    
	if (detalles>0) 
	{
		$("#btnGuardar").show();
	}
	else
	{
		$("#btnGuardar").hide();
		cont=0;
	}
}


function eliminarDetalle(indice){
	$("#fila"+indice).remove();
	calcularTotales();
	detalles=detalles-1;
}

init();